using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;			// for StreamWriter I/O to a file
using System.Text;			// for Encoding I/O to a Text file

namespace MyNamespace
{
	/// <summary>
	///		Goldbach - Goldbach's Conjecture - Run.
	///
	/// ---------------- *** LEGAL NOTICE: *** ------------------
	///
	/// This program is free software; you can redistribute it and/or modify
	/// it under the terms of the GNU General Public License (GPL) as published
	/// by the Free Software Foundation. cf. the file COPYING.txt.
	///
	/// ------------ *** end of legal notice *** ------------------
	/// </summary>

	public class RunForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		public RunForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
			Global.runTextOut = richTextOut;
			Global.runTextOut.Clear();
			Global.objRunForm = this;
		}

		/// <summary>
		///	Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RunForm));
			this.mainMenuRun = new System.Windows.Forms.MainMenu(this.components);
			this.menFile = new System.Windows.Forms.MenuItem();
			this.menuReadSnapShot = new System.Windows.Forms.MenuItem();
			this.menuWriteAll = new System.Windows.Forms.MenuItem();
			this.menuWriteSnapShot = new System.Windows.Forms.MenuItem();
			this.menuWriteResults = new System.Windows.Forms.MenuItem();
			this.menuTestTooLarge = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuPause = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuHighest = new System.Windows.Forms.MenuItem();
			this.menuAboveNormal = new System.Windows.Forms.MenuItem();
			this.menuNormal = new System.Windows.Forms.MenuItem();
			this.menuBelowNormal = new System.Windows.Forms.MenuItem();
			this.menuLowest = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuHelpForm = new System.Windows.Forms.MenuItem();
			this.menuAbout = new System.Windows.Forms.MenuItem();
			this.richTextOut = new System.Windows.Forms.RichTextBox();
			this.labelTitle = new System.Windows.Forms.Label();
			this.labelStatus = new System.Windows.Forms.Label();
			this.timerRun = new System.Windows.Forms.Timer(this.components);
			this.buttonReadSnapShot = new System.Windows.Forms.Button();
			this.buttonWriteResults = new System.Windows.Forms.Button();
			this.buttonPause = new System.Windows.Forms.Button();
			this.buttonWriteSnapShot = new System.Windows.Forms.Button();
			this.buttonTestTooLarge = new System.Windows.Forms.Button();
			this.buttonQuit = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// mainMenuRun
			// 
			this.mainMenuRun.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menFile,
            this.menuItem1,
            this.menuHelp});
			// 
			// menFile
			// 
			this.menFile.Index = 0;
			this.menFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuReadSnapShot,
            this.menuWriteAll,
            this.menuWriteSnapShot,
            this.menuWriteResults,
            this.menuTestTooLarge,
            this.menuItem5,
            this.menuPause,
            this.menuExit});
			this.menFile.Text = "&File";
			// 
			// menuReadSnapShot
			// 
			this.menuReadSnapShot.Index = 0;
			this.menuReadSnapShot.Text = "&Read SnapShot";
			this.menuReadSnapShot.Click += new System.EventHandler(this.menuReadSnapShot_Click);
			// 
			// menuWriteAll
			// 
			this.menuWriteAll.Index = 1;
			this.menuWriteAll.Text = "Write &All";
			this.menuWriteAll.Click += new System.EventHandler(this.menuWriteAll_Click);
			// 
			// menuWriteSnapShot
			// 
			this.menuWriteSnapShot.Index = 2;
			this.menuWriteSnapShot.Text = "&Write SnapShot";
			this.menuWriteSnapShot.Click += new System.EventHandler(this.menuWriteSnapShot_Click);
			// 
			// menuWriteResults
			// 
			this.menuWriteResults.Index = 3;
			this.menuWriteResults.Text = "Write R&esults";
			this.menuWriteResults.Click += new System.EventHandler(this.menuWriteResults_Click);
			// 
			// menuTestTooLarge
			// 
			this.menuTestTooLarge.Index = 4;
			this.menuTestTooLarge.Text = "Test \'&Too Large\'";
			this.menuTestTooLarge.Click += new System.EventHandler(this.menuTestTooLarge_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 5;
			this.menuItem5.Text = "-";
			// 
			// menuPause
			// 
			this.menuPause.Index = 6;
			this.menuPause.Text = "&Pause";
			this.menuPause.Click += new System.EventHandler(this.menuPause_Click);
			// 
			// menuExit
			// 
			this.menuExit.Index = 7;
			this.menuExit.Text = "E&xit";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuHighest,
            this.menuAboveNormal,
            this.menuNormal,
            this.menuBelowNormal,
            this.menuLowest});
			this.menuItem1.Text = "Priority";
			// 
			// menuHighest
			// 
			this.menuHighest.Index = 0;
			this.menuHighest.RadioCheck = true;
			this.menuHighest.Text = "Highest";
			this.menuHighest.Click += new System.EventHandler(this.menuHighest_Click);
			// 
			// menuAboveNormal
			// 
			this.menuAboveNormal.Index = 1;
			this.menuAboveNormal.RadioCheck = true;
			this.menuAboveNormal.Text = "AboveNormal";
			this.menuAboveNormal.Click += new System.EventHandler(this.menuAboveNormal_Click);
			// 
			// menuNormal
			// 
			this.menuNormal.Index = 2;
			this.menuNormal.RadioCheck = true;
			this.menuNormal.Text = "Normal";
			this.menuNormal.Click += new System.EventHandler(this.menuNormal_Click);
			// 
			// menuBelowNormal
			// 
			this.menuBelowNormal.Index = 3;
			this.menuBelowNormal.RadioCheck = true;
			this.menuBelowNormal.Text = "BelowNormal";
			this.menuBelowNormal.Click += new System.EventHandler(this.menuBelowNormal_Click);
			// 
			// menuLowest
			// 
			this.menuLowest.Index = 4;
			this.menuLowest.RadioCheck = true;
			this.menuLowest.Text = "Lowest";
			this.menuLowest.Click += new System.EventHandler(this.menuLowest_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Index = 2;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuHelpForm,
            this.menuAbout});
			this.menuHelp.Text = "&Help F1";
			// 
			// menuHelpForm
			// 
			this.menuHelpForm.Index = 0;
			this.menuHelpForm.Text = "&Help Form        F1";
			this.menuHelpForm.Click += new System.EventHandler(this.menuHelpForm_Click);
			// 
			// menuAbout
			// 
			this.menuAbout.Index = 1;
			this.menuAbout.Text = "&About...";
			this.menuAbout.Click += new System.EventHandler(this.menuAbout_Click);
			// 
			// richTextOut
			// 
			this.richTextOut.BackColor = System.Drawing.SystemColors.Window;
			this.richTextOut.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.richTextOut.Location = new System.Drawing.Point(0, 120);
			this.richTextOut.Name = "richTextOut";
			this.richTextOut.ReadOnly = true;
			this.richTextOut.Size = new System.Drawing.Size(656, 296);
			this.richTextOut.TabIndex = 0;
			this.richTextOut.Text = "";
			this.richTextOut.KeyDown += new System.Windows.Forms.KeyEventHandler(this.richTextOut_KeyDown);
			// 
			// labelTitle
			// 
			this.labelTitle.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelTitle.Location = new System.Drawing.Point(50, 8);
			this.labelTitle.Name = "labelTitle";
			this.labelTitle.Size = new System.Drawing.Size(594, 40);
			this.labelTitle.TabIndex = 1;
			this.labelTitle.Text = "Goldbach\'s Conjecture";
			// 
			// labelStatus
			// 
			this.labelStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.labelStatus.Location = new System.Drawing.Point(12, 56);
			this.labelStatus.Name = "labelStatus";
			this.labelStatus.Size = new System.Drawing.Size(361, 56);
			this.labelStatus.TabIndex = 2;
			this.labelStatus.Text = "Status";
			// 
			// timerRun
			// 
			this.timerRun.Enabled = true;
			this.timerRun.Interval = 500;
			this.timerRun.Tick += new System.EventHandler(this.timerRun_Tick);
			// 
			// buttonReadSnapShot
			// 
			this.buttonReadSnapShot.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonReadSnapShot.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonReadSnapShot.Location = new System.Drawing.Point(370, 56);
			this.buttonReadSnapShot.Name = "buttonReadSnapShot";
			this.buttonReadSnapShot.Size = new System.Drawing.Size(104, 23);
			this.buttonReadSnapShot.TabIndex = 3;
			this.buttonReadSnapShot.Text = "Read SnapShot";
			this.buttonReadSnapShot.Click += new System.EventHandler(this.buttonReadSnapShot_Click);
			// 
			// buttonWriteResults
			// 
			this.buttonWriteResults.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonWriteResults.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonWriteResults.Location = new System.Drawing.Point(484, 56);
			this.buttonWriteResults.Name = "buttonWriteResults";
			this.buttonWriteResults.Size = new System.Drawing.Size(104, 23);
			this.buttonWriteResults.TabIndex = 4;
			this.buttonWriteResults.Text = "Write Results";
			this.buttonWriteResults.Click += new System.EventHandler(this.buttonWriteResults_Click);
			// 
			// buttonPause
			// 
			this.buttonPause.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonPause.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonPause.Location = new System.Drawing.Point(598, 56);
			this.buttonPause.Name = "buttonPause";
			this.buttonPause.Size = new System.Drawing.Size(48, 23);
			this.buttonPause.TabIndex = 5;
			this.buttonPause.Text = "Pause";
			this.buttonPause.Click += new System.EventHandler(this.buttonPause_Click);
			// 
			// buttonWriteSnapShot
			// 
			this.buttonWriteSnapShot.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonWriteSnapShot.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonWriteSnapShot.Location = new System.Drawing.Point(370, 88);
			this.buttonWriteSnapShot.Name = "buttonWriteSnapShot";
			this.buttonWriteSnapShot.Size = new System.Drawing.Size(104, 23);
			this.buttonWriteSnapShot.TabIndex = 6;
			this.buttonWriteSnapShot.Text = "Write SnapShot";
			this.buttonWriteSnapShot.Click += new System.EventHandler(this.buttonWriteSnapShot_Click);
			// 
			// buttonTestTooLarge
			// 
			this.buttonTestTooLarge.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonTestTooLarge.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonTestTooLarge.Location = new System.Drawing.Point(484, 88);
			this.buttonTestTooLarge.Name = "buttonTestTooLarge";
			this.buttonTestTooLarge.Size = new System.Drawing.Size(104, 24);
			this.buttonTestTooLarge.TabIndex = 7;
			this.buttonTestTooLarge.Text = "Test \'Too Large\'";
			this.buttonTestTooLarge.Click += new System.EventHandler(this.buttonTestTooLarge_Click);
			// 
			// buttonQuit
			// 
			this.buttonQuit.Cursor = System.Windows.Forms.Cursors.Hand;
			this.buttonQuit.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonQuit.Location = new System.Drawing.Point(598, 88);
			this.buttonQuit.Name = "buttonQuit";
			this.buttonQuit.Size = new System.Drawing.Size(48, 23);
			this.buttonQuit.TabIndex = 8;
			this.buttonQuit.Text = "Quit";
			this.buttonQuit.Click += new System.EventHandler(this.buttonQuit_Click);
			// 
			// RunForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(656, 414);
			this.Controls.Add(this.buttonQuit);
			this.Controls.Add(this.buttonTestTooLarge);
			this.Controls.Add(this.buttonWriteSnapShot);
			this.Controls.Add(this.buttonPause);
			this.Controls.Add(this.buttonWriteResults);
			this.Controls.Add(this.buttonReadSnapShot);
			this.Controls.Add(this.labelStatus);
			this.Controls.Add(this.labelTitle);
			this.Controls.Add(this.richTextOut);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenuRun;
			this.Name = "RunForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Goldbach - Goldbach\'s Conjecture - Run";
			this.Resize += new System.EventHandler(this.RunForm_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.memberFormClosing);
			this.ResumeLayout(false);

		}
		#endregion

		private System.Windows.Forms.MenuItem menFile;
		private System.Windows.Forms.MenuItem menuReadSnapShot;
		private System.Windows.Forms.MenuItem menuWriteSnapShot;
		private System.Windows.Forms.MenuItem menuWriteResults;
		private System.Windows.Forms.MenuItem menuTestTooLarge;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuPause;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.MenuItem menuAbout;
		private System.Windows.Forms.Label labelTitle;
		private System.Windows.Forms.Label labelStatus;
		private System.Windows.Forms.MainMenu mainMenuRun;
		private System.Windows.Forms.Timer timerRun;
		private System.Windows.Forms.Button buttonReadSnapShot;
		private System.Windows.Forms.Button buttonWriteResults;
		private System.Windows.Forms.Button buttonPause;
		private System.Windows.Forms.Button buttonWriteSnapShot;
		private System.Windows.Forms.Button buttonTestTooLarge;
		private System.Windows.Forms.Button buttonQuit;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuHelpForm;
		private MenuItem menuWriteAll;
		private MenuItem menuItem1;
		private MenuItem menuHighest;
		private MenuItem menuAboveNormal;
		private MenuItem menuNormal;
		private MenuItem menuBelowNormal;
		private MenuItem menuLowest;
		private System.Windows.Forms.RichTextBox richTextOut;

		public void Run(int iQSize, int iRSize, int iJLim, int iCyc, int iPri, StartupForm callerForm)
		{
			try
			{
				if (Global.runFormUp) { Dispose(true); return; }
				Global.runFormUp = true;
				int i;			// index for table of primes
				Global.SetPriority(iPri);	// execution priority
				CheckPrioity();	// checkmark priority on Priority menu
				cyc = iCyc;		// cycles per status output
				rSize = iRSize;	// size of saved arrays
				nS = new double[rSize + 1];	// saved n
				q1 = new double[rSize + 1];	// saved p_i
				q2 = new double[rSize + 1];	// saved p_j
				ti = new string[rSize+1];	// saved sTime
				mi = new double[rSize+1];	// saved ways
				new NPrimes();				// initialize class NPrimes
				new NPrimes(iJLim, iQSize); // initialize NPrimes package
				mC = iJLim;		// NB: if SnapShot files are used, mC must be iJLim
								// and iJLim cannot be changed between write and read.
				qSize = iQSize;	// size of IQ and JQ arrays, must be large enough
								// to hold all primes <= Sqrt(Maximum integer testable)
				objStartupForm = callerForm;
				this.Cursor = Cursors.Arrow;
				flagQuit = false;
				flagPause = false;
				flagWriteSnapShot = false;
				flagReadSnapShot = false;
				flagWriteResults = false;
				flagTooLarge = false;
				flagOnlyATest = false;
				labelTitle.Text = Global.name1 + "\n" + Global.name2;
				rFile = Global.pName + "RFile.txt";
				rFBak = Global.pName + "Rfile.Bak";
				rFToo = Global.pName + "RFile.Too";
				sSFile = Global.pName + "SnapS.txt";
				sSFBak = Global.pName + "SnapS.Bak";
				pi = 0;
				time0 = Environment.TickCount/1000;
				Global.PLn("The system was booted-up " + FormatTime(time0) + " ago.");
				timeP = time0;
				TimeIt();
				timeS = timeD;
				mi[1] = 0; nS[1] = 1; q1[1] = 0; q2[1] = 0; ti[1] = sTime;
				mi[2] = 1; nS[2] = 2; q1[2] = 2; q2[2] = 2; ti[2] = sTime;
				mi[3] = 1; nS[3] = 3; q1[3] = 3; q2[3] = 3; ti[3] = sTime;
				ai = 3;
				startI = 4;
				int ap = ai;
				nPS = 2;
				PrintCurrent();
				nr = NPrimes.NPrime(mC, flagOnlyATest);
				for (i = startI; ; i++)
				{
					n = i;
					ai++;
					nS[ai] = n;
					double ways = NoOfWays(n, out q1[ai], out q2[ai]);
					if (flagQuit)
						return;
					if (SnapShotRead)
					{
						i = (int)n;		// n might have changed
						SnapShotRead = false;
						continue;
					}
					mi[ai] = ways;
					TimeIt();
					ti[ai] = sTime;
					int j;
					for (j = ai - 1; j > 0; j--)
					{
						if (ways > mi[j])
							break;
					}
					j++;
					if (j < ai)
					{
						mi[j] = mi[ai];
						nS[j] = nS[ai];
						q1[j] = q1[ai];
						q2[j] = q2[ai];
						ti[j] = ti[ai];
						ai = j;
					}
					if (ai > ap)
					{
						ap = ai;
						Global.Prn(" " + ap);
					}
					if (i % 100 == 0 || mC < 100)
					{
						DoEvents();
						if (flagQuit)
							return;
						i = (int)n;		// n might have changed
						SnapShotRead = false;
					}
				}
			}
			catch (System.IndexOutOfRangeException caught)
			{
				DialogResult key = MessageBox.Show(caught.Message,
					Global.title + " - Exception",
					MessageBoxButtons.OK,
					MessageBoxIcon.Asterisk); // display message.
				flagTooLarge = true;
				WriteResults();
				WriteSnapShot();
				WaitToQuit();
				return;
			}
			catch (System.SystemException caught)
			{
				DialogResult key = MessageBox.Show(caught.Message,
					Global.title + " - Exception",
					MessageBoxButtons.OK,
					MessageBoxIcon.Asterisk); // display message.
				WaitToQuit();
				return;
			}
		} // Run

		private void DoEvents()
		{
			Application.DoEvents(); // process user requested actions;
			if (flagReadSnapShot)
			{
				ReadSnapShot();
				SnapShotRead = true;
			}
			if (flagWriteResults) WriteResults();
			if (flagWriteSnapShot) WriteSnapShot();
			if (flagPause) WaitForPause();
			if (flagQuit) { WaitToQuit(); return; }
			if (flagOnlyATest)			// test "Too Large"
				mi[rSize + 1] = 0;		// cause an index out-of-bounds exception
			prCnt++;
			if (prCnt >= cyc)
			{
				TimeIt();
				labelStatus.Text =
					"Prime no. table length = " + nr + " of " + qSize + "\n" +
					"Current results array index = " + ai + " of " + rSize + "\n" +
					"Max prime tested = " + p1.ToString("#,###");
				// other method is string.Format("Max prime tested = {0}", p1);

				if (richTextOut.TextLength > 20000)
				{   // clear screen after about 5 pages
					richTextOut.Text = "";		// to prevent out-of-memory error
					PrintCurrent();
				}
				if (timeD - timeS > 3600)		// force write files every hour
				{
					WriteResults();
					WriteSnapShot();
					timeS = timeD;
				}
				prCnt = 0;
			}
		} // DoEvents

		private int NoOfWays(double n, out double pa, out double pb)
		// returns the number of ways 2n = pi+pj (pi, pj primes pi<=pj)
		{
			int w = 0;		// w = nunmer of ways
			int nP = nPS;	// nP = next prime index
			double q = 0;	// q = next prime
			double r;		// r = 2 * n - q
			pa = 0.0;
			pb = 0.0;
			while (q < n)
			{
				nP++;
				q = NPrimes.iP[nP];
			
			}
			nPS = nP - 1;
			while (true)
			{
				r = n + n - q;
				if (r < 0)			// last one found?
					break;
				bool prime = true;	// is r a prime?
				double d = 1;
				if (r < 3)
				{
					prime = false;
					d = r;
				}
				while (true)
				{
					d += 2;
					long rem;
					if (Math.DivRem((long)r, (long)d, out rem) < d)
						break;		// exit while
					if (rem == 0)
					{
						prime = false;
						break;		// exit while
					}
				}
				if (prime)
				{
					w++;
					pa = r;
					pb = q;
				}
				nP++;
				q = NPrimes.iP[nP];
				if (q > p1)
				{
					p1 = q;
					pi = nP;
				}
				if (nP % 100 == 0)
				{
					DoEvents();
					if (SnapShotRead || flagQuit)
						return 0;
				}
			}
			return w;
		} // NoOfWays

		private void PrintCurrent()
		{
			Global.PLn("");
			Global.DisplayPriority();
			Global.Prn("Current array index:");
			prCnt = 30000; // force status output next cycle
		}

		private void ReadSnapShot() // read SnapShot file from disk and continue from there
		{
			int k;
			int kk;
			string line;
			string[] fields;
			readSSFile = null;
			try
			{
				Global.runTextOut.Text = "";			// clear text output window
				Global.PLn("The system was booted-up " + FormatTime(Environment.TickCount/1000) + " ago.");
				TimeIt();
				Global.PLn("");
				Global.PLn("Reading SnapShot File: " + sSFile);
				readSSFile = new StreamReader(sSFile);	// open the file
				bool done = false;
				do
				{
					line = readSSFile.ReadLine();		// read in next line
					Global.PLn(line);
					line = Global.DeleteExtraDelimiters(line);
					fields = line.Split(' ');			// convert the string to an array, each number is separated by a space
					string field2 = "";
					if (fields.Length > 1) field2 = fields[1];
					if (field2 == "SnapShot:") done = true;
				}
				while (!done);
				line = readSSFile.ReadLine();			// read in next line
				line = Global.DeleteExtraDelimiters(line);
				fields = line.Split(' ');				// convert the string to an array, each number is separated by a space
				pi	   = Convert.ToDouble( fields[0] );
				p1 = Convert.ToDouble(fields[1]);
				n = Convert.ToDouble(fields[2]);
				startI = Convert.ToInt32(fields[3]);
				prCnt  = Convert.ToInt32 ( fields[4] );
				mC	   = Convert.ToInt32 ( fields[5] );
				Global.PLn(" " + pi + " " + p1 + " " + n + " " + startI + " " + prCnt + " " + mC);
				line = readSSFile.ReadLine();			// read in next line
				Global.PLn(line);
				line = readSSFile.ReadLine();			// read in next line
				line = Global.DeleteExtraDelimiters(line);
				fields = line.Split(' ');				// convert the string to an array, each number is separated by a space
				timeD  = Convert.ToInt32( fields[0] );
				Global.PLn(" " + timeD);
				time0 = time1 - timeD;
				TimeIt();
				timeS = timeD;
				line = readSSFile.ReadLine();			// read in next line
				fields = line.Split(' ');				// convert the string to an array, each number is separated by a space
				ai = Convert.ToInt32( fields[1] );
				Global.PLn(fields[0] + " " + ai);
				if (ai >= rSize)
				{
					rSize = 2 * ai; // size of saved arrays
					nS = new double[rSize + 1]; // saved n
					q1 = new double[rSize + 1]; // saved p_i
					q2 = new double[rSize + 1]; // saved p_j
					ti = new string[rSize + 1]; // saved sTime
					mi = new double[rSize + 1]; // saved ways
				}
				for (k = 1; k <= ai; k++)
				{
					line = readSSFile.ReadLine();		// read in next line
					line = Global.DeleteExtraDelimiters(line);
					fields = line.Split(' ');			// convert the string to an array, each number is separated by a space
					kk = Convert.ToInt32(fields[0]);
					nS[k] = Convert.ToDouble(fields[1]);
					q1[k] = Convert.ToDouble(fields[2]);
					q2[k] = Convert.ToDouble(fields[3]);
					ti[k] = Convert.ToString(fields[5]);
					mi[k] = Convert.ToDouble(fields[6]);
					if (k == 1 || k == ai)
					{
						Global.PLn(kk + " " + q1[k] + " " + q2[k] + " " + 2 * kk + " " +
							RSt(ti[k], 1) + " " + mi[k]);
					}
					if (k == 1) Global.PLn(" . . .");
				}
				line = readSSFile.ReadLine();				// read in next line
				Global.PLn(line);
			}
			catch(Exception e)
			{
				Global.PLn("Exception: " + e.Message);		// file not found
			}
			finally
			{
				flagReadSnapShot = false;
				if (readSSFile != null)
				{
					readSSFile.Close();						// close the file
					PrintCurrent();
				}
			}
		}

		private void TimeIt() // -------- Get time for printout
		{
			time1 = Environment.TickCount/1000; // the number of milliseconds since Windows started.
			if (time1 < timeP) time0 = time0 - (int) (Math.Pow(2, 31)/1000); // timeCount cycles 2^31 mills = 24.855 days
			timeP = time1;
			timeD = time1 - time0;
			sTime = FormatTime(timeD);
		}

		private void WaitForPause()
		{
			buttonPause.Text = "OK";
			DisableClicks();
			TimeIt();							// timeD = time1 - time0. Allow for time paused.
			int timeDSave = timeD;
			DialogResult key = MessageBox.Show(Global.pName + " is Paused. OK to Resume?",
				Global.title,
				MessageBoxButtons.OK,
				MessageBoxIcon.Information);	// display message.
			// The Pause That Refreshes -----------------------------
			TimeIt();
			time0 = time1 - timeDSave;			// allow for time-out.
			flagPause = false;
			buttonPause.Text = "Pause";
			EnableClicks();
			buttonPause.Focus();
		}

		private bool TestQuit()
		{
			DialogResult key = MessageBox.Show("Are you sure you want to quit?",
				Global.title,
				MessageBoxButtons.YesNo,
				MessageBoxIcon.Question);
			if (key == DialogResult.Yes)
			{
				DisableClicks();
				flagQuit = true;
			}
			return key == DialogResult.Yes;
		}

		private void WaitToQuit()
		{
			try
			{
				DisableClicks();
				for(;;)
				{
					Application.DoEvents();
					if (flagQuit)			// wait for user Quit request
					{
						objStartupForm.Show();
						Dispose(true);
						Global.runFormUp = false;
						return;
					}
				}
			}
			catch (System.SystemException)
			{
				StartupForm.flagAbort = true;
				Dispose(true);
			}
		} // WaitToQuit

		private void WriteResults() // write accumulated table to screen and file
		{
			StreamWriter writeRFile = null;
			Global.runTextOut.Text = ""; // clear text output window
			DateTimePicker dateTime = new System.Windows.Forms.DateTimePicker();
			string dateTimeString = dateTime.Value.ToString();
			TimeIt();

			try
			{
				
				if (ai > rSize)
					ai = rSize;
				if (flagTooLarge)
				{
					// open RFToo For Output As writeRFile
					writeRFile = new StreamWriter(rFToo, false, Encoding.ASCII); //Appending = false
				}
				else
				{
					if (System.IO.File.Exists(rFile))		// if no primary, don't delete the backup
					{
						if (System.IO.File.Exists(rFBak))	// if backup exists ...
						{
							System.IO.File.Delete(rFBak);	// delete Results backup file
						}
						System.IO.File.Move(rFile, rFBak);	// save previous Results file as a backup (rename)
					}
					//Open RFile For Output As writeRFile
					writeRFile = new StreamWriter(rFile, false, Encoding.ASCII); //Appending = false
				}
				writeRFile.WriteLine("");
				writeRFile.WriteLine(Global.name1);
				writeRFile.WriteLine(Global.name2);
				writeRFile.WriteLine(Global.version);
				writeRFile.WriteLine(Global.author);
				writeRFile.WriteLine(Global.address);
				if (flagTooLarge)
				{
					TOut(writeRFile, "");
					TOut(writeRFile, "        >>>>>>>>>>>> Numbers got too large! <<<<<<<<<<<<");
				}
				TOut(writeRFile, "");
				TOut(writeRFile, Global.pName + ": Max prime tested =" + RSt(p1, 13) + "  #" +
					RSt(pi, 11) + RSt(sTime, 13));
				TOut(writeRFile, "");
				TOut(writeRFile, "  SEQUENCE: A135733                                Elapsed");
				TOut(writeRFile, "    n         k       p_i       p_j        2k       Time        Ways");
				int kk = 1;
				mi[0] = -1;
				for (int k = 1; k <= ai; k++)
				{
					for (double j = mi[k] - mi[k - 1] - 1; j >= 0; j--)
					{
						TOut(writeRFile, RSt(kk, 5) + RSt(nS[k], 10) + RSt(q1[k], 10) + RSt(q2[k], 10) +
							RSt(2 * nS[k], 10) + RSt(ti[k], 13) + RSt(mi[k] - j, 10));
						kk++;
					}
				}
				TOut(writeRFile, "End of table!");
				TOut(writeRFile, dateTimeString);
				TOut(writeRFile, Global.pName + ": Max prime tested =" + RSt(p1, 13) + "  #" +
					RSt(pi, 11) + RSt(sTime, 13));
				if (flagTooLarge)
				{
					TOut(writeRFile, "");
					TOut(writeRFile, "        >>>>>>>>>>>> Numbers got too large! <<<<<<<<<<<<");
					if (flagOnlyATest)
					{
						TOut(writeRFile, "");
						TOut(writeRFile, "  Not really, This Is Only A Test!");
					}
				}
				else
				{
					PrintCurrent();
				}
			}
			catch (Exception e)
			{
				Global.PLn("Exception: " + e.Message);
			}
			finally
			{
				flagWriteResults = false;
				if (writeRFile != null)
				{
					writeRFile.Close();	//Close the file
				}
			}
		} // WriteResults

		private void WriteSnapShot() // SnapShot all current data to disk and continue
		{
			writeSSFile = null;
			int k;

			DateTimePicker dateTime = new System.Windows.Forms.DateTimePicker();
			string dateTimeString = dateTime.Value.ToString();
			TimeIt();

			try
			{
				if (ai > rSize)
					ai = rSize;
				Global.PLn("");
				Global.PLn("");
				Global.PLn("Intermediate prime number table length = " + qSize);
				Global.PLn("Size of results table = " + rSize);
				Global.PLn("Prime numbers generated per cycle = " + mC);
				Global.PLn("Number of cycles per status output = " + cyc);
				Global.PLn("");
				Global.Prn(" SnapShot - Begin ... ");
				if (System.IO.File.Exists(sSFile))			// if no primary, don't delete the backup
				{
					if (System.IO.File.Exists(sSFBak))		// if backup exists ...
					{
						System.IO.File.Delete(sSFBak);		// delete SnapShot backup file
					}
					System.IO.File.Move(sSFile, sSFBak);	// save previous SnapShot file as a backup (rename)
				}
				// open sSFile For Output As writeSSFile
				writeSSFile = new StreamWriter(sSFile, false, Encoding.ASCII); //Appending = false
				writeSSFile.WriteLine("File written by: " + Global.version);
				writeSSFile.WriteLine("SYSTEM = " + Environment.GetEnvironmentVariable("SYSTEM"));
				writeSSFile.WriteLine("File = " + sSFile + "  " + dateTimeString);
				writeSSFile.WriteLine("");
				writeSSFile.WriteLine(Global.pName + " SnapShot: pi; p1; n; startI; prCnt; mC");
				writeSSFile.WriteLine(" " + pi + " " + p1 + " " + n + " " + startI + " " + prCnt + " " + mC);
				writeSSFile.WriteLine("Elapsed Time (sec):");
				writeSSFile.WriteLine(" " + timeD);
				writeSSFile.WriteLine("ai " + ai);
				for (k = 1; k <= ai; k++)
				{
					writeSSFile.Write(k);
					writeSSFile.Write(" " + nS[k]);
					writeSSFile.Write(" " + q1[k]);
					writeSSFile.Write(" " + q2[k]);
					writeSSFile.Write(" " + 2 * nS[k]);
					writeSSFile.WriteLine(" \"" + ti[k] + "\" " + mi[k]);
				}
				writeSSFile.WriteLine("End of File " + sSFile + "  (qSize = " + qSize + ", rSize = " + rSize + ")");
			}
			catch(Exception e)
			{
				Global.PLn("Exception: " + e.Message); //
			}
			finally
			{
				Global.PLn("End");
				if (writeSSFile != null)
				{
					writeSSFile.Close();	//Close the file
				}
				flagWriteSnapShot = false;
				PrintCurrent();
				timeS = timeD;
			}
		} // WriteSnapShot

		private void DisableClicks()
		{
			buttonReadSnapShot.Enabled = false;
			buttonWriteSnapShot.Enabled = false;
			buttonWriteResults.Enabled = false;
			buttonTestTooLarge.Enabled = false;
			buttonPause.Enabled = false;
			menuReadSnapShot.Enabled = false;
			menuWriteSnapShot.Enabled = false;
			menuWriteResults.Enabled = false;
			menuTestTooLarge.Enabled = false;
			menuPause.Enabled = false;
			menuHelpForm.Enabled = false;
			menuAbout.Enabled = false;
			buttonQuit.Enabled = false;
			menuExit.Enabled = false;
		}

		private void EnableClicks()
		{
			buttonReadSnapShot.Enabled = true;
			buttonWriteSnapShot.Enabled = true;
			buttonWriteResults.Enabled = true;
			buttonTestTooLarge.Enabled = true;
			buttonPause.Enabled = true;
			menuReadSnapShot.Enabled = true;
			menuWriteSnapShot.Enabled = true;
			menuWriteResults.Enabled = true;
			menuTestTooLarge.Enabled = true;
			menuPause.Enabled = true;
			menuHelpForm.Enabled = true;
			menuAbout.Enabled = true;
			buttonQuit.Enabled = true;
			menuExit.Enabled = true;
		}

		private string FormatTime(int t) // t in total seconds >= 0
		{
			int iSS = t % 60;			t -= iSS;
			int iMM = (t / 60) % 60;	t -= iMM * 60;
			int iHH = (t / 3600) % 24;
			int iDD = (t - iHH * 3600) / 86400;
			if (iDD > 0) iHH += 500;
			string sSS = Convert.ToString(500 + iSS);
			string sMM = Convert.ToString(500 + iMM);
			string sHH = Convert.ToString(iHH);
			string sDD = Convert.ToString(iDD);
			string st =":" + sMM.Substring(1,2) + ":" + sSS.Substring(1,2);
			if (iDD > 0)
				st = sDD + "/" + sHH.Substring(1,2) + st;
			else
				st = sHH + st;
			return st; // return format is "0:00:00" ... "...99/23:59:59")
		}

		private void TOut(StreamWriter sw, string st) // print to textOut window and output to the open file
		{
			Global.PLn(st);
			sw.WriteLine(st);
		}

		private string RSt(string st, int n) // format with leading blanks for at least n columns
		{
			int m = st.Length + 1;	// at least one new blank
			if (m < n) m = n;		// and at least n characters
			return st.PadLeft(m,' ');
		}

		private string RSt(double d, int n) // format with leading blanks for at least n columns
		{
			string st = Convert.ToString(d);
			return RSt(st, n);
		}

		private void buttonPause_Click(object sender, System.EventArgs e)
		{
			flagPause = true;
		}

		private void buttonQuit_Click(object sender, System.EventArgs e)
		{
			TestQuit();
		}

		private void buttonWriteSnapShot_Click(object sender, System.EventArgs e)
		{
			flagWriteSnapShot = true;
		}

		private void buttonReadSnapShot_Click(object sender, System.EventArgs e)
		{
			flagReadSnapShot = true;
		}

		private void buttonWriteResults_Click(object sender, System.EventArgs e)
		{
			flagWriteResults = true;
		}

		private void buttonTestTooLarge_Click(object sender, System.EventArgs e)
		{
			DisableClicks();
			flagOnlyATest = true;
		}

		private void menuAbout_Click(object sender, System.EventArgs e)
		{
			try
			{
				AboutForm aboutForm = new AboutForm();
				aboutForm.ShowDialog();
				if (aboutForm.DialogResult == DialogResult.OK)
				{
					aboutForm.Dispose();
				}
			}
			catch(Exception ex)
			{
				System.Console.WriteLine(ex.Message.ToString());
			}
		}

		private void menuHelpForm_Click(object sender, System.EventArgs e)
		{
			HelpForm();
		}

		private void HelpForm()
		{
			if (Global.helpUp < 3)	// allow at most 3 Help Forms up
			{
				HelpForm objHelpForm = new HelpForm();
				objHelpForm.Show();
				objHelpForm.Help();
			}
		}

		private void menuPause_Click(object sender, System.EventArgs e)
		{
			flagPause = true;
		}

		private void menuReadSnapShot_Click(object sender, System.EventArgs e)
		{
			flagReadSnapShot = true;
		}

		private void menuTestTooLarge_Click(object sender, System.EventArgs e)
		{
			DisableClicks();
			flagOnlyATest = true;
		}

		private void menuWriteAll_Click(object sender, EventArgs e)
		{
			flagWriteResults = true;
			flagWriteSnapShot = true;
		}


		private void menuWriteResults_Click(object sender, System.EventArgs e)
		{
			flagWriteResults = true;
		}

		private void menuWriteSnapShot_Click(object sender, System.EventArgs e)
		{
			flagWriteSnapShot = true;
		}

		private void menuExit_Click(object sender, System.EventArgs e)
		{
			buttonQuit_Click(sender, e);
		}

		private void CheckPrioity()	// checkmark priority on Priority menu
		{
			menuHighest.Checked = (Global.pri == 2);
			menuAboveNormal.Checked = (Global.pri == 1);
			menuNormal.Checked = (Global.pri == 0);
			menuBelowNormal.Checked = (Global.pri == -1);
			menuLowest.Checked = (Global.pri == -2);
		}

		private void menuHighest_Click(object sender, EventArgs e)
		{
			Global.SetPriority(2);
			CheckPrioity();
		}

		private void menuAboveNormal_Click(object sender, EventArgs e)
		{
			Global.SetPriority(1);
			CheckPrioity();
		}

		private void menuNormal_Click(object sender, EventArgs e)
		{
			Global.SetPriority(0);
			CheckPrioity();
		}

		private void menuBelowNormal_Click(object sender, EventArgs e)
		{
			Global.SetPriority(-1);
			CheckPrioity();
		}

		private void menuLowest_Click(object sender, EventArgs e)
		{
			Global.SetPriority(-2);
			CheckPrioity();
		}

		private void timerRun_Tick(object sender, System.EventArgs e)
		{
			Application.DoEvents();
		}

		private void RunForm_Resize(object sender, System.EventArgs e)
		{
			int jTop = buttonQuit.Top + buttonQuit.Height + 7;
			this.richTextOut.SetBounds(1, jTop, this.ClientRectangle.Width - 2, this.ClientRectangle.Height - jTop -1);
		}

		private void memberFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			e.Cancel = true;
			TestQuit();
		}

		private void richTextOut_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.F1)	// display the Help form
				HelpForm();
		}

		private StartupForm objStartupForm;
		private bool flagReadSnapShot;
		private bool SnapShotRead;
		private bool flagWriteSnapShot;
		private bool flagWriteResults;
		private bool flagTooLarge;
		private bool flagPause;
		private bool flagQuit;
		private int  qSize;		// size of IQ and JQ arrays, must be large enough
								// to hold all primes <= Sqrt(Maximum integer testable)
		private int		cyc;	// cycles per status output
		private string	sTime;	// elapsed time in D/HH:MM:SS format
		private int		ai;		// index for sequences store
		private int		mC;		// number of primes each call of function NPrime
		private double	n;		// next number to test
		private int		nPS;	// next prime index saved for NoOfWays
		private double	pi;		// count of the number of primes = pi(p1)
		private double	p1;		// Max prime tested
		private int		prCnt;	// count for print status
		private int		nr;		// the current length of the internal tables returned by NPrime(mC)
		private string	rFile;	// file name for Results file
		private string	rFBak;	// file name for Results Back=up file
		private string	rFToo;	// file name for Results file after a TOO LARGE alarm
		private int		rSize;	// size of saved arrays
		private string	sSFile;	// file name for SnapShot file
		private string	sSFBak;	// file name for SnapShot Back-up file
		private int		startI;	// start value for i in DO LOOP
		private int		time0;	// time in seconds of start of run
		private int		time1;	// current time in seconds = Environment.TickCount / 1000;
		private int		timeD;	// time duration in seconds of report (time1 - time0)
		private int		timeP;	// previous time
		private int		timeS;	// time of last SnapShot
		private double[] nS;	// saved n
		private double[] q1;	// saved p_i
		private double[] q2;	// saved p_j
		private string[] ti;	// saved sTime
		private double[] mi;	// saved ways
		private bool flagOnlyATest;			// test flag for testing "Numbers got too large!"
		private StreamReader readSSFile;	// StreamReader for the SnapShot file
		private StreamWriter writeSSFile;	// StreamWriter for the SnapShot file
		public static int helpHeight = 520;	// current height of the Help Form in pixels
		public static int helpWidth = 702;	// current width of the Help Form in pixels
	}
}
